/***********************************************************************\ 
*									* 
*   File: scorpion/src/IDLlib/libidl/iniacktrl.c 
*				 					* 
*   Copyright (C) 1991 Ralph Cook
*									* 
*   The Scorpion System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you 	* 
*   retain credits referencing the University of Arizona and that you	* 
*   identify any changes you make.					* 
*									* 
*   Report problems to scorpion-project@cs.arizona.edu			* 
*   Direct all inquiries to:	The Scorpion Project			* 
*				Department of Computer Science		* 
*				Gould-Simpson Building			* 
*				University of Arizona			* 
*				Tucson, AZ 85721			* 
*				U.S.A.					* 
*									* 
*   Revision Log:							* 
*	$Log:$ 
*									* 
*   Edit Log:								* 
*									* 
\***********************************************************************/ 

#ifndef lint 
static char rcsid[] = "$Header:$"; 
#endif 

/* iniacktrl -- initialize acknowledgement trailer
 * 
 *  9-Oct-1988 15:49 -- created.  Ralph Cook
 * 20-Nov-1988 15:26 -- expanded documentation.
 */

#include "ivw.h"

/* An acknowledgement trailer is a structure sent after
 * "additional message" bytes in inter-process comm in
 * IDLView.  The idea is that, if communications are
 * aborted before completion, a process which has posted
 * a read can get 'hung' waiting for a message which does
 * not come.  The ack trailer alleviates this by allowing
 * the sending process to trap the error and send a message
 * which does not contain a valid ack message, thereby allowing
 * the reader to complete the read and then take action.
 */

void iniacktrl (trladr)
  char trladr[ACKTRLSIZ];
{ trladr[0] = 's';
  trladr[1] = 's';
}
