/***********************************************************************\ 
*									* 
*   File: scorpion/src/idlbrowse/command.h 
*				 					* 
*   Copyright (C) 1991 Marco Chierotti
*									* 
*   The Scorpion System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you 	* 
*   retain credits referencing the University of Arizona and that you	* 
*   identify any changes you make.					* 
*									* 
*   Report problems to scorpion-project@cs.arizona.edu			* 
*   Direct all inquiries to:	The Scorpion Project			* 
*				Department of Computer Science		* 
*				Gould-Simpson Building			* 
*				University of Arizona			* 
*				Tucson, AZ 85721			* 
*				U.S.A.					* 
*									* 
*   Revision Log:							* 
*	$Log:$ 
*									* 
*   Edit Log:								* 
*									* 
\***********************************************************************/ 

/*
 *
 *  Description: Header file for the Command Module. It interprets at high
 *               level the interactive commands  calling the Windows Module 
 *               and calls for queries on the Candle structure calling the
 *               Candle Module to do so.
 */

/**************************************************************************/


/*
 *  Routine: command_interpreter 
 *
 *  Description: it initializes the interactive environment, interprets
 *               commands and calls the corresponding routines. At level 3
 *               it sets the screen using selections and zoom options
 *
 *  Arguments: nsel -- (IN) number of selections on command line
 *             selections -- (IN) array of string with selections
 *             zoom_flag -- (IN) true if zoom mode selected in
 *                               command line.
 *             NOTE: if not at level 3, all arguments are dummy!!!!!
 *
 *  Return Value: none
 *
 *  Side Effects: none
 *
 */
void command_interpreter(/*nsel, selections, zoom_flag*/);
/*  int nsel;
    char selections[][];
    boolean zoom_flag; */



