/***********************************************************************\ 
*									* 
*   File: scorpion/src/treewalk/up.h 
*				 					* 
*   Copyright (C) 1991 Aaron Cavender
*									* 
*   The Scorpion System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you 	* 
*   retain credits referencing the University of Arizona and that you	* 
*   identify any changes you make.					* 
*									* 
*   Report problems to scorpion-project@cs.arizona.edu			* 
*   Direct all inquiries to:	The Scorpion Project			* 
*				Department of Computer Science		* 
*				Gould-Simpson Building			* 
*				University of Arizona			* 
*				Tucson, AZ 85721			* 
*				U.S.A.					* 
*									* 

*   Revision Log:							* 
*	$Log:$ 
*									* 
*   Edit Log:								* 
*									* 
\***********************************************************************/ 


/*
 *	Description :	This, as you have surmised, the header file
 *			for up.c
 */


/**** DECLARATIONS ****/

/*
 *	Routine :	list()
 *
 *	Description :	Probably the most abused of all the commands, list()
 *			displays the information of the current item.  List()
 *			requires 2 arguments, which must be positive or
 *			NULL.  If any of the arguments are NULL, then default
 *			value for that argument is used.  All the information
 *			printed to stdout should either fit onto the screen
 *			or be terminated before wrapping around the screen.
 *
 *	Arguments :	start	- (IN) the attribute number to begin printing
 *				  the current node.  If start is 0, then
 *				  begin printing from the last line printed.
 *			finish	- (IN) the last line to be printed in the
 *				  current node.  If finish == 0, then default
 *				  to the maximum number of attributes that
 *				  fit on one screen.
 *
 *	Return Value :	None.
 *
 *	Side Effects :	None.
 */

extern nodeDesc Root;
